=== debian/changelog ===
eliom (11.1.1-4build1) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 22 Oct 2025 22:51:26 +0200

eliom (11.1.1-4) unstable; urgency=medium

  * Bring js_of_ocaml 6.2.0 changes more in line with upstream changes

 -- Stéphane Glondu <glondu@debian.org>  Fri, 12 Sep 2025 09:54:05 +0200

eliom (11.1.1-3) unstable; urgency=medium

  * Fix compilation with js_of_ocaml 6.2.0 and ppxlib 0.36.0
  * Bump Standards-Version to 4.7.2

 -- Stéphane Glondu <glondu@debian.org>  Fri, 12 Sep 2025 09:04:31 +0200

eliom (11.1.1-2) unstable; urgency=medium

  * Add support for OCaml 5.3 (Closes: #1093101)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 29 Jan 2025 03:05:10 +0100

eliom (11.1.1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 01 Jan 2025 16:39:18 +0100
