=== debian/control ===
Source: eliom
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-ocaml (>= 2),
 ocaml,
 ocaml-findlib,
 ocaml-dune (>= 3.6),
 ocamlbuild,
 libppx-deriving-ocaml-dev,
 libjs-of-ocaml-dev (>= 6.2.0),
 libjs-of-ocaml-ocamlbuild-ocaml-dev,
 liblwt-log-ocaml-dev,
 liblwt-ocaml-dev,
 libtyxml-ocaml-dev (>= 4.4.0),
 libocsigenserver-ocaml-dev (>= 5.1.0),
 libocsipersist-ocaml-dev,
 libipaddr-ocaml-dev (>= 2.1),
 libreactivedata-ocaml-dev (>= 0.2.1),
 libppxlib-ocaml-dev (>= 0.36.0),
 libppx-optcomp-ocaml-dev,
 opam-installer
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: http://ocsigen.org/eliom
Vcs-Browser: https://salsa.debian.org/ocaml-team/eliom
Vcs-Git: https://salsa.debian.org/ocaml-team/eliom.git

Package: eliom
Architecture: any
Depends:
 libeliom-ocaml-dev,
 ocaml-findlib,
 js-of-ocaml,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 libeliom-ocaml-doc
Replaces: libeliom-ocaml-dev (<< 3)
Breaks: libeliom-ocaml-dev (<< 3)
Description: web framework for ocsigenserver (tools)
 Eliom allows one to easily develop sophisticated client/server Web
 applications using OCaml.
 .
 This package contains command-line tools.

Package: libeliom-ocaml-dev
Architecture: any
Depends:
 libppx-deriving-ocaml-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends:
 ocaml-findlib
Breaks: libeliom-ocaml (<< 4.2)
Replaces: libeliom-ocaml (<< 4.2)
Description: web framework for ocsigenserver (dev libraries)
 Eliom allows one to easily develop sophisticated client/server Web
 applications using OCaml.
 .
 This package contains all the library files needed to use Eliom.
