=== debian/watch ===
version=4
https://github.com/ocsigen/eliom/tags .*/([0-9.]+)\.tar\.gz
